image: hub.coinplug.com/public/docker:latest
variables:
  GIT_BRANCH: ${CI_COMMIT_REF_NAME}
  IMAGE_TAG: "stage"
  IMAGE_VERSION_TAG: ${CI_COMMIT_SHORT_SHA}
stages:
  - review
  - build
  - deploy


workflow:
  rules:
    - if: $CI_COMMIT_BRANCH == "develop" || $CI_COMMIT_BRANCH == "gitlabci"
      variables:
        IMAGE_TAG: "develop"
        ENVIRONMENT_CONFIG: ${STAGE_ENV}
    - if: $CI_PIPELINE_SOURCE == "web" && $CI_COMMIT_BRANCH == "master"
      variables:
        IMAGE_TAG: "latest"
        IMAGE_VERSION_TAG: "master-$CI_COMMIT_SHORT_SHA"
        ENVIRONMENT_CONFIG: ${PROD_ENV}
    - if: $CI_PIPELINE_SOURCE == "web" && $CI_COMMIT_TAG
      variables:
        IMAGE_TAG: "latest"
        IMAGE_VERSION_TAG: ${CI_COMMIT_TAG}
        ENVIRONMENT_CONFIG: ${PROD_ENV}

review:
  stage: review
  script:
    - echo "Review information...."
    - echo "Branch >> $GIT_BRANCH, commit >> $IMAGE_VERSION_TAG"
    - echo "Tag >> $CI_COMMIT_TAG"
#    - echo "CI_PIPELINE_SOURCE >> $CI_PIPELINE_SOURCE"
#    - echo "CI_REGISTRY >> $CI_REGISTRY"
  only:
    - master
    - develop
    - gitlabci
    - tags

build_image:
  stage: build
  before_script:
    - echo "$ENVIRONMENT_CONFIG" > .env
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker pull $CI_REGISTRY_DEPENDENCE_IMAGE:$IMAGE_TAG || true
    - docker build --target dependencies --cache-from $CI_REGISTRY_DEPENDENCE_IMAGE:$IMAGE_TAG --tag $CI_REGISTRY_DEPENDENCE_IMAGE:$IMAGE_TAG -f Dockerfile .
    - docker push $CI_REGISTRY_DEPENDENCE_IMAGE:$IMAGE_TAG

    - docker pull $CI_REGISTRY_IMAGE:$IMAGE_TAG || true
    - docker build --cache-from $CI_REGISTRY_IMAGE:$IMAGE_TAG --cache-from $CI_REGISTRY_DEPENDENCE_IMAGE:$IMAGE_TAG --tag $CI_REGISTRY_IMAGE:$IMAGE_VERSION_TAG --tag $CI_REGISTRY_IMAGE:$IMAGE_TAG -f Dockerfile .
    - docker push $CI_REGISTRY_IMAGE:$IMAGE_VERSION_TAG
    - docker push $CI_REGISTRY_IMAGE:$IMAGE_TAG
  needs:
    - review
  only:
    - master
    - develop
    - gitlabci
    - tags

deploy_stage:
  stage: deploy
  variables:
    SERVER_ADDRESS: ${STAGE_SERVER}
    USER_REMOTE: ${STAGE_REMOTE_USER}
    USER_ACCESS_KEY: ${STAGE_REMOTE_ACCESS_KEY}
  before_script:
    - apk add openssh-client
    - apk add --update coreutils
    - eval $(ssh-agent -s)
    - mkdir -p ~/.ssh
    - echo "$USER_ACCESS_KEY" | base64 -d | tr -d '\r' | ssh-add -
    - chmod 700 ~/.ssh
  script:
    - echo "Start build develop version ....."
    - ssh -o StrictHostKeyChecking=no $USER_REMOTE@$SERVER_ADDRESS "cd ${STAGE_CWD}; docker-compose pull && docker-compose down && docker-compose up -d --scale swap.ui=${STAGE_NUMBER_INSTANCE}"
  only:
    - develop
    - gitlabci
  needs:
    - build_image

deploy_product_01:
  stage: deploy
  variables:
    SERVER_ADDRESS: ${PROD_01_SERVER}
    USER_REMOTE: ${PROD_REMOTE_USER}
    USER_ACCESS_KEY: ${PROD_REMOTE_ACCESS_KEY}
  before_script:
    - apk add openssh-client
    - apk add --update coreutils
    - eval $(ssh-agent -s)
    - mkdir -p ~/.ssh
    - echo "$USER_ACCESS_KEY" | base64 -d | tr -d '\r' | ssh-add -
    - chmod 700 ~/.ssh
  script:
    - echo "Start build backend-01 server ....."
    - ssh -o StrictHostKeyChecking=no $USER_REMOTE@$SERVER_ADDRESS "cd ${PROD_CWD}; docker-compose pull; docker-compose down && docker-compose up -d --scale swap.ui=${PROD_NUMBER_INSTANCE}"
  only:
    - master
    - tags
  needs:
    - build_image

deploy_product_02:
  stage: deploy
  variables:
    SERVER_ADDRESS: ${PROD_02_SERVER}
    USER_REMOTE: ${PROD_REMOTE_USER}
    USER_ACCESS_KEY: ${PROD_REMOTE_ACCESS_KEY}
  before_script:
    - apk add openssh-client
    - apk add --update coreutils
    - eval $(ssh-agent -s)
    - mkdir -p ~/.ssh
    - echo "$USER_ACCESS_KEY" | base64 -d | tr -d '\r' | ssh-add -
    - chmod 700 ~/.ssh
  script:
    - echo "Start build backend-02 server ....."
    - ssh -o StrictHostKeyChecking=no $USER_REMOTE@$SERVER_ADDRESS "cd ${PROD_CWD}; docker-compose pull; docker-compose down && docker-compose up -d --scale swap.ui=${PROD_NUMBER_INSTANCE}"
  only:
    - master
    - tags
  needs:
    - build_image
